/**
 Partitziile unui numar natural.
 Ex: n=4
1 1 1 1
1 1 2
1 2 1
1 3
2 1 1
2 2
3 1
4
analiza:
1) Org.shirului de solutzii shi domenii
  in shir bagam direct elementele unei partitzii.
!!SPre deosebire de pb. permutarilor, solutziile au un numar
variabil de elemente.
  O solutzie la un moment dat este
     x[1],x[2],..,x[k]  cu k variabile

Domeniile: in primul rind, pentru optimizare, remarcam ca ne-ar
fi al naibii de util sa cunoashtem, inainte sa-i dam valori]
unui x[k], suma elementelor de dinaintea sa.
Gen:
  daca avem n=11
shi am pus deja elementele
4 1 2 1 [?]   care sunt valide shi au suma 8
remarcam ca, dupa ele, mai putem pune un element cuprins intre
        1 shi 3  (deci 1 shi n-s)
Ashadar, la problema asta vom introduce un parametru
suplimentar la functzia recursiva de back, parametrul "s"
care va avea la fiecare intrare pe un nivel k, valoarea sumei
celor anterioare, aka x[1]+x[2]+..+x[k-1]

  domeniile:
     x[k] apartzine de la 1..n-s

2) Valid: Mereu

3) Solutzie: s+x[k]==n

4) Fara prelungire
*/
#include <iostream>
using namespace std;

int n,x[30];

void afish(int k)
{
    int i;
    for(i=1;i<=k;i++)
        cout<<x[i]<<" ";
    cout<<"\n";
}

void back(int k,int s)
{
    for(x[k]=1;x[k]<=n-s;x[k]++)
        if(s+x[k]==n)
            afish(k);
        else
            back(k+1,s+x[k]);
}

int main()
{
    cin>>n;
    back(1,0);
    return 0;
}
