/**
 Se citeshte n. SA se genereze TOATE submultzimile multzimii
{1,2,..,n}
 Metoda 1: cu vector caracteristic.

Vector caracteristic: o modalitate de a descrie in mod unic orice
submultzime cu ajutorul unui vector binar, astfel:
 v[k] =0 daca elementul k NU apartzine submultzimii descrise de vector
 v[k] =1 daca elementul k apartzine submultzimii descrise de vector
Ex:
n=8 shi submultzimea
{2,4,5,7,8}
Ea este descrisa de vectorul caracteristic:
(0,1,0,1,1,0,1,1)

Problema se reduce de fapt la generarea tuturor vectorilor
caracteristici cu n elemente.
Analiza:
1) Organizarea shirului de solutzii shi domenii:
  generam de fapt vectorul caracteristic shi NU direct submultzimea
astfel x[k]  apartzine 0..1

2) Valid: mereu

3) Solutzie: k==n

4) Fara prelungire
*/
#include <iostream>
using namespace std;

int x[30],n;

void afish()
{
    int i;
    cout<<"{ ";
    for(i=1;i<=n;i++)
        if(x[i])cout<<i<<" ";
    cout<<"}\n";
}

void back(int k)
{
    for(x[k]=0;x[k]<=1;x[k]++)
        if(k==n)afish();
        else back(k+1);
}

int main()
{
    cin>>n;
    back(1);
    return 0;
}
