/**
 Metoda 2 de generare submultzimi: in ordine lexicografica,
 backtracking cu prelungire.
Ex:
n=4
{ 1 }
{ 1 2 }
{ 1 2 3 }
{ 1 2 3 4 }
{ 1 3 }
{ 1 3 4 }
{ 1 4 }
{ 2 }
{ 2 3 }
{ 2 3 4 }
{ 2 4 }
{ 3 }
{ 3 4 }
{ 4 }
Analiza:
 1) Organizare shir solutzii shi domenii:
 in shirul de solutzii punem DIRECT elementele submultzimilor.
Solutziile au numar variabil de elemente.
Domenii:
  x[k] apartzine de la x[k-1]+1 .. n

 2) Valid: mereu

 3) Solutzie: mereu

 4) !! ESTE PROBLEMA CU PRELUNGIRE !!
*/
#include <iostream>
using namespace std;

int n,x[30];

void afish(int k)
{
    int i;
    cout<<"{ ";
    for(i=1;i<=k;i++)
        cout<<x[i]<<" ";
    cout<<"}\n";
}

void back(int k)
{
    for(x[k]=x[k-1]+1;x[k]<=n;x[k]++)
    {
        afish(k);
        back(k+1);
    }
}

int main()
{
    cin>>n;
    back(1);
    return 0;
}
