#include <iostream>
#include <fstream>
#include <cmath>
#include <climits>
using namespace std;

int niv(int k)
{
    double n=(-1+sqrt(1+8*k))/2;
    if(n==(int)n)return n;
    return (int)n+1;
}

int cp[1300];
unsigned long long a[1300];//a=umplerea la pasul curent
int sum[60],n,nt;
unsigned long long surplus;

int testare(unsigned long long cant)
{//aceasta functzie va simula caderea unei cantitatzi
    //cant asupra intregului set de pahare
   //functzia ne va da 0 daca au ramas pahare
   // neumplute, 1 daca toate paharele de pe ultimul
   //nivel sunt pline, indiferent kt a dat pe-afara
   surplus=0;
   int i,fs;//fs=fiul de pe stinga
   unsigned long long st,dr;
   for(i=1;i<=nt;i++)a[i]=0;//a[i] = umplerea
   a[1]=cant;
   for(i=1;i<=nt-n;i++)
   {
       if(a[i]>cp[i])//umplerea > capacitatea
       {//distribui surplusul:
           st=dr=(a[i]-cp[i])/2;
           if((a[i]-cp[i])%2)st++;
           fs=i+niv(i);
           a[fs]+=st;
           a[fs+1]+=dr;
       }
   }
   int exista_neumplute=0;
   for(i=nt-n+1;i<=nt;i++)
   {
       if(a[i]>cp[i])surplus+=a[i]-cp[i];
       if(a[i]<cp[i])exista_neumplute=1;
   }
   if(exista_neumplute)return 0;
   return 1;
}

int main()
{
    ifstream fin("pic.in");
    ofstream fout("pic.out");
    int v,i;
    fin>>v>>n;
    nt=n*(n+1)/2;
    for(i=1;i<=nt;i++)fin>>cp[i];
    if(v==1)
    {
        for(i=1;i<=nt;i++)
            sum[niv(i)]+=cp[i];
        //facem un maxim al lui sum tzinind shi nivelul
        int vmax=sum[1],kmax=1;
        for(i=2;i<=n;i++)
            if(sum[i]>vmax)
            {
                vmax=sum[i];
                kmax=i;
            }
        fout<<kmax;
    }
    else
    {
        unsigned long long li=0,lf=ULLONG_MAX,m;
        m=(li+lf)/2;
        int test;
        while(li<=lf)
        {
            test=testare(m);
            if(test==0)
                    li=m+1;
            else
                lf=m-1;
            m=(li+lf)/2;
        }
        cout<<li<<" "<<surplus;
    }
    return 0;
}
