#include <iostream>
#include <fstream>
#include <cmath>
#include <climits>
using namespace std;

int niv(int nr)
{
    double k=(-1+sqrt(1+8*nr))/2;
    if(k==(int)k)return k;
    return (int)k+1;
}

int a[1300],n,m;
long long u[1300],surplus;
//n=kte pahare sunt pe ultimul nivel
//m=kte pahare sunt in total
//u[i] = cit de plin este paharul i la un moment dat

int curge(long long total)
{
    int i,fiu;
    for(i=1;i<=m;i++)u[i]=0;
    u[1]=total;
    surplus=0;
    long long over;
    for(i=1;i<=m-n;i++)
        if(u[i]>a[i])//umplerea depasheshte capacitatea
        {
            over=u[i]-a[i];//cit curge afara din paharul i
            fiu=i+niv(i);
            u[fiu]+=(over+1)/2;
            u[fiu+1]+=over/2;
        }
    int toate_pline=1;
    for(i=m-n+1;i<=m;i++)//iau doar paharele de pe ult. nivel
        if(u[i]<a[i])toate_pline=0;
        else
            surplus+=u[i]-a[i];
    return toate_pline;
}

int main()
{
    ifstream fin("pic.in");
    ofstream fout("pic.out");
    int v,i,k;
    fin>>v>>n;
    m=n*(n+1)/2;
    for(i=1;i<=m;i++)
        fin>>a[i];
    if(v==1)
    {//ne ocupam de cazul ushor: nivelul minim cu suma maxima
        int smax=0,nivsmax=1,s,npc=0;
        for(k=1;k<=n;k++)//luam nivel cu nivel
        {
            s=0;
            for(i=npc+1;i<=npc+k;i++)
                s+=a[i];
            npc+=k;
            if(s>smax){smax=s;nivsmax=k;}
        }
        fout<<nivsmax;
    }
    else
    {
        long long li=0,lf=LONG_LONG_MAX,m;
        m=(li+lf)/2;
        while(li<=lf)
        {
            int rez=curge(m);
            if(rez==0) li=m+1;
            else lf=m-1;
            m=(li+lf)/2;
        }
        fout<<li<<" "<<surplus;
    }
    return 0;
}
