/**
 Partitiile unei submultzimi
a) Org. shirului de solutzii shi domenii

  Shirul de solutzii este de fapt vectorul caracteristic
ce descrie o partizie, definit astfel:
    x[k] = numarul submultzimii din care face parte
           elementul de valoare k.
Ex:
   x=(1,1,2,1,2,1,1,3,2,1,3)
va reprezenta partitzia:
     {1,2,4,6,7,10}  {3,5,9} {8,11}

Domenii:
   vom introduce un parametru suplimentar "max" la functzia
de back, parametru in care, la fiecare intrare pe un nivel
k, max=maximul elementelor{x[1],x[2],...x[k-1]}
   deci maximul elementelor de dinainte.
  Avem grija ca la fiecare nou apel sa-l actualizam
corespunzator.

  In acest caz, domeniile vor fi fiind:
      x[k] apartzine 1..max+1
La apelul initzial, pt. a avea valoare corecta shi pt. x[1]
vom considera parametrul max=0

b) Valid: mereu

c) Solutzie: k==n

d) Fara prelugire
*/
#include <iostream>
using namespace std;

int x[30],n;

void afish(int nm)
{
    int i,j;
    for(i=1;i<=nm;i++)
    {
        cout<<"{ ";
        for(j=1;j<=n;j++)
            if(x[j]==i)cout<<j<<" ";
        cout<<"}  ";
    }
    cout<<"\n";
}

void back(int k,int max)
{
    int newmax;
    for(x[k]=1;x[k]<=max+1;x[k]++)
    {
        newmax=max;
        if(x[k]>newmax)newmax=x[k];
        if(k==n)afish(newmax);
            else back(k+1,newmax);
    }
}

int main()
{
    cin>>n;
    back(1,0);
    return 0;
}
