/**
 Memoria se poate accesa la nivel de octet.
 Fiecare octet este numerotat, deci are un indice.
Acest indice se numeshte "adresa".
  De adresele de memorie se ocupa Sistemul de Operare.
  Utilizatorul NU poate sa le ocupe in mod direct ci,
prin intermediul sistemului de operare sa lucreze cu ele.
*/
#include <iostream>
using namespace std;

int main()
{
    int a;//Am declarat o variabila statica
    //<=>de la inceputul pina la finalul programului
    //ii este alocata o adresa care NU poate fi
    //modificata
    cout<<&a<<"\n";//cu & in fatza unei variabile
    //statice aflam adresa ei de memorie
    //Consultarea este pur teoretica, nu ne ajuta
    //cu nimic adresa de memeorie efectiva
    //valoarea se afisheaza in baza 16. 0x in fatza
    //numarului <=> hexazecimal
    int *b;  //asta este pointer
    //<=> pointer = o variabila care, imediat dupa de-
    //clarare este HOMELESS <=> NU are alocata
    //nicio adresa de memorie (in fine, ca la nr.
//variabilele normale, are o valoare aleatorie, care
//nu reprezinta insa o adesa valida
    cout<<b<<"\n";//a se remarca faptul ca nu am pu &b
    //fiind pointer print "b" se intzelege adresa de
    //memorie. Prin *b s-ar intzelege VALOAREA de la
    //adresa respectiva
    a=176;
    b=&a;//am dus pointerul peste a <=> este o "capusa"
    //devine de fapt un sinonim al lui a
    cout<<*b;
    *b=55;//am modificat valoarea de la adresa respectiva
    //deci de fapt shi a-ul
    cout<<"\n"<<a;
    b=new int;//operatorul "new" cauta o adresa de
    //memorie libera shi i-o da lui b.
    //b-ul, prin aceasta, "pleaca" de pe a.
    *b=69;
    cout<<"\n"<<*b;
    cout<<"\n"<<a;
    //Obs: *b inseamna FIX acelashi lucru cu b[0]
    cout<<"\n"<<b[0];
    return 0;
}
