/**
 Citim n. Afisham numerele prime cuprinse
 intre 1 shi n, in fishierul nrpr.txt

Varianta eficienta: generarea numerelor prime o vom face
cu Ciurul lui Eratostene
  pe care-l implementam cu un vector de marcare
*/
#include <iostream>
#include <fstream>
using namespace std;

//vectorii mari se declara OBLIGATORIU inainte de main.
//orice variabila de fapt se poate declara inainte de main
//o astfel de variabila se numeshte "globala" shi in plus are
//avanatajul de a se initzializa de la mama ei cu 0
int ciur[10000010];

int main()
{
    int n,i,x;
    ofstream fout("nrpr.txt");
    n=10000000;
    ciur[0]=ciur[1]=1;
    x=1;
    while(x<=n)
    {//determin primul numar care NU e marcat
        x++;
        while(x<=n && ciur[x]==1)x++;
        i=2*x;
        while(i<=n)
        {
            ciur[i]=1;
            i+=x;
        }
    }
    for(i=1;i<=n;i++)
        if(!ciur[i])fout<<i<<" ";
    return 0;
}
