/**
  Eficientizarea lucrului cu numere mari consta in
gruparea cifrelor retzinute astfel incit cif[..] sa
retzine grupuri de acelashi numar de cifre (gen 4,5,6,7,8)
in loc de 1 singura.

  Pe programul de fatza vom retzine grupuri de kte 8 cifre
*/
#include <iostream>
#include <iomanip>
#include <cstring>
#define number_of_digits_per_element 8
#define number_of_digits_power 100000000//deci 10 la a 8a
using namespace std;



struct nr_mare
            {
                int nc,cif[1000];
                //nc=numarul de cifre
            };

void citire(nr_mare &x)
{
    char s[1001];
    cin.getline(s,1001);
    x.nc=0;
    int nr=0,p=1,pozcif=0;
    for(int i=strlen(s)-1;i>=0;i--)
    {
        nr=nr+(s[i]-'0')*p;
        p*=10;
        pozcif++;
        if(pozcif%number_of_digits_per_element==0||i==0)
        {
            x.cif[x.nc++]=nr;
            nr=0;p=1;
        }
    }
}

void afish(nr_mare x)
{
    cout<<x.cif[x.nc-1];
    for(int i=x.nc-2;i>=0;i--)
        cout<<setw(number_of_digits_per_element)<<
        setfill('0')<<x.cif[i];
    setfill(' ');
}

nr_mare suma(nr_mare a,nr_mare b)
{
    nr_mare c;
    c.nc=b.nc;
    if(a.nc>b.nc)c.nc=a.nc;
    int i,t=0;
    //il completez cu 0 pe-ala mai scurt
    for(i=a.nc;i<c.nc;i++)a.cif[i]=0;
    for(i=b.nc;i<c.nc;i++)b.cif[i]=0;
    for(i=0;i<c.nc;i++)
    {
        c.cif[i]=(t+a.cif[i]+b.cif[i])%number_of_digits_power;
        t=(t+a.cif[i]+b.cif[i])/number_of_digits_power;
    }
    if(t)c.cif[c.nc++]=t;
    return c;
}

nr_mare produs(nr_mare a,nr_mare b)
{
    nr_mare c;int i,k;
    long long t=0;
    c.nc=a.nc+b.nc-1;
    for(i=a.nc;i<c.nc;i++)a.cif[i]=0;
    for(i=b.nc;i<c.nc;i++)b.cif[i]=0;
    for(i=0;i<c.nc;i++)
    {
        long long aux=0;
        for(k=0;k<=i;k++)
            aux+=(long long)a.cif[k]*b.cif[i-k];
        c.cif[i]=(aux+t)%number_of_digits_power;
        t=(aux+t)/number_of_digits_power;
    }
    while(t)
        c.cif[c.nc++]=t%number_of_digits_power,
        t/=number_of_digits_power;
    return c;
}


int main()
{
    nr_mare x,y,z;
    citire(x);
    citire(y);
    cout<<"S-or citit:\n";
    afish(x);
    cout<<"\n";
    afish(y);
    cout<<"\nSuma:\n";
    z=suma(x,y);
    afish(z);
    cout<<"\n";
    z=produs(x,y);
    afish(z);
    return 0;
}
