/**
  In c++ obiectele sunt declarate cu "class" de aceea avem sinonimie
     obiect=clasa
  Instantziere a unei clase: alocarea de memorie shi resurse pentru o anumita
clasa.

   Definirea clasei: definirea tipului respectiv, insa in stare latenta
       (el nu este folosit pina nu declaram shi folosim o variabila
        de tipul respectiv)


  Instantzierea: folosirea unei clase prin intermediul unei variabile pe care
fie o folosim in mod clasic (statica) fie o declaram ca pointer shi o alocam.
*/

#include <iostream>
#include <cmath>
using namespace std;

class cplx
        {
        private:
            double re,im;
            //constructorul se declara astfel: !!el NU are tip:
        public:
            cplx()
            {
                //asta e constructorul implicit - se activeaza la declararea unei
                //clase fara parametri
                cout<<"S-a activat constructorul clasei\n";
            }
//supraincarc constructorul:
            cplx(double x,double y)
            {//acest constructor permite alocarea de valori pt. re shi im din declarare
                cout<<"S-a activat constructorul cu 2 parametri\n";
                re=x;im=y;
            }

            cplx(double x)
            {
                re=x;
                im=0;
            }

            ~cplx()
            {
                //asta e desctructorul - el NU are niciodata parametri
                cout<<"S-a activat destructorul clasei\n";
            }

            double modul()
            {
                return sqrt(re*re+im*im);
            }
        };


void test()
{
    cplx z;
    cout<<"Amu sunt in interiorul functziei\n";
}

int main()
{
    cplx z1=8;
    cout<<z1.modul()<<"\n";
    cout<<"Apel functzie:\n";
    test();
    //declarare dinamica a clasei:
    cout<<"Alocare shi dezalocare pointer:\n";
    cplx *z;
    z=new cplx(5);
    cout<<z->modul()<<"\n";
    delete z;
    return 0;
}
